﻿Imports System.Collections.ObjectModel
Imports UoWTestApp.Core.Repositories

Namespace Persistence.Repositories
    Public Class CurrenciesRepository
        Inherits Repository(Of Currency)
        Implements ICurrenciesRepository

        Public Sub New(ByVal context As UoWTestAppModel)
            MyBase.New(context)
        End Sub

        Public ReadOnly Property dbo As UoWTestAppModel
            Get
                Return TryCast(Context, UoWTestAppModel)
            End Get
        End Property

        Public Overloads Function Add(Optional vNewCurrency As Currency = Nothing) As Currency Implements ICurrenciesRepository.Add
            If vNewCurrency Is Nothing Then
                vNewCurrency = New Currency With {.CurrConversionRateDate = Date.Now}
            End If
            Context.Set(Of Currency)().Add(vNewCurrency)
            Context.Entry(vNewCurrency).State = System.Data.Entity.EntityState.Added
            Return vNewCurrency
        End Function

        Public Function GetBySQL(SQLSearchTerm As String) As ListCollectionView Implements ICurrenciesRepository.GetBySQL
            Throw New NotImplementedException()
        End Function
    End Class
End Namespace
